 program vector_lab
implicit none 
real :: a,b,c,beta
 real :: h,k,l
 real, dimension(3):: ed,exL,eyL,ezL,Pa,Pb,Pc,Ep,va,vb,vc,eE
 real, parameter:: rad=atan(1.)/45., sq2=sqrt(2.)
 real length,alphad
! a = 5.8765 (3), b = 7.1100 (3), c = 8.4892 (5) 
! monoclinic crystal
  c=8.4892; b= 7.1100;  a= 5.8765 
  beta=111.096
  h=1; k=0; l=0
! vector va= a*(sin(beta)*ex+ cos(beta)*ey), vb=b*ez, vc= c*ey
 
  va(1)=a*sin(beta*rad); va(3)=a*cos(beta*rad); va(2)=0.
  vb=0.; vb(2)=b
  vc=0.; vc(3)=c

! plane (hkl) is defined by the points Pa=va/h, Pb=vb/k, Pc=vc/l 
! k=0 => vector vb is a vector in the plane
! l=0 => vector vc is a vector in the plane
! => vector va is normal to the plane : rotation axis

  write(6,*)'va/h=',va/h
 
 write(6,'(a)')' rotation axis ed |_ Ep in the plane ey,ez (b,c)'

  alphad= 0        

  write(6,'(/,a,f12.4,/)')'   angle < (ex,ed)=',alphad

   ed=0.; ed(1)=1.
  write(6,*)'rotation vector ed=',ed

 write(6,'(/,a)')'<(ez_lab,ed)=45°, -ex in between ex_lab,ez_lab '

  exL(1)=-cos((alphad+45)*rad); exL(2)=-sin((alphad+45)*rad); exL(3)=0
  ezL(1)=-cos((alphad-45)*rad); ezL(2)=-sin((alphad-45)*rad); ezL(3)=0

  write(6,'(a,3f8.3,a,3f8.3,a1)')'ebx=(',exL,')  ebz=(',ezl,')'

  write(6,'(/,a)')'<(ez_lab,ed)=45°, ex in between ex_lab,ez_lab '
  exL(1)=cos((alphad-45)*rad); exL(2)=sin((alphad-45)*rad); exL(3)=0
  ezL(1)=cos((alphad+45)*rad); ezL(2)=sin((alphad+45)*rad); ezL(3)=0
  write(6,'(a,3f8.3,a,3f8.3,a1,/)')'ebx=(',exL,')  ebz=(',ezl,')'
 
 print*,' the Lab system with ezL parallel to the rotation axis' 

 exL=0.; exL(2)=1.
 ezL=ed

  write(6,'(a,3f8.4,a,3f8.4,a1,/)')'ebx=(',exL,')  ebz=(',ezL,')'
!the program euler calculates the Euler angle of the transformation
!from Lab to crystal system.


  stop
  end
